# -*- coding: euc-kr -*-

# Main ToasterBoxDemo

import wx, easyhanrss
import ToasterBox as TB

# In Case Of TB_COMPLEX Style, Create A Panel That Contains An Image, Some
# Text, An Hyperlink And A Ticker.

import wx.lib.hyperlink as hyperlink
from wx.lib.ticker import Ticker

#----------------------------------------------------------------------
# Get Some Icon/Data
#----------------------------------------------------------------------

def GetMondrianData():
    return \
'\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00 \x00\x00\x00 \x08\x06\x00\
\x00\x00szz\xf4\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\x00qID\
ATX\x85\xed\xd6;\n\x800\x10E\xd1{\xc5\x8d\xb9r\x97\x16\x0b\xad$\x8a\x82:\x16\
o\xda\x84pB2\x1f\x81Fa\x8c\x9c\x08\x04Z{\xcf\xa72\xbcv\xfa\xc5\x08 \x80r\x80\
\xfc\xa2\x0e\x1c\xe4\xba\xfaX\x1d\xd0\xde]S\x07\x02\xd8>\xe1wa-`\x9fQ\xe9\
\x86\x01\x04\x10\x00\\(Dk\x1b-\x04\xdc\x1d\x07\x14\x98;\x0bS\x7f\x7f\xf9\x13\
\x04\x10@\xf9X\xbe\x00\xc9 \x14K\xc1<={\x00\x00\x00\x00IEND\xaeB`\x82' 

def GetMondrianBitmap():
    return wx.BitmapFromImage(GetMondrianImage())

def GetMondrianImage():
    import cStringIO
    stream = cStringIO.StringIO(GetMondrianData())
    return wx.ImageFromStream(stream)

def GetMondrianIcon():
    icon = wx.EmptyIcon()
    icon.CopyFromBitmap(GetMondrianBitmap())
    return icon

# ------------------------------------------------------------------------------ #
# Class ToasterBoxDemo
#    This Class Implements The Demo For ToasterBox Control. Try To Change The
#    Style Using The RadioBox In The Upper Section Of The Frame, And See How
#    ToasterBox Acts.
# ------------------------------------------------------------------------------ #

class ToasterBoxDemo(wx.Frame):
	def __init__(self, parent, id=wx.ID_ANY, title="EasyHanRss", pos = wx.DefaultPosition, size=(0,0)):
		wx.Frame.__init__(self, parent, id, title, pos, size, style=wx.FRAME_NO_TASKBAR|wx.NO_FULL_REPAINT_ON_RESIZE )
		self.SetIcon(GetMondrianIcon())

		self.tbicon = wx.TaskBarIcon()
		icon = wx.Icon('icon.ico', wx.BITMAP_TYPE_ICO)
		self.tbicon.SetIcon(icon, ' ư  ')
		self.tbicon.Bind(wx.EVT_TASKBAR_LEFT_UP, self.OnExit)
		self.tbicon.Bind(wx.EVT_TASKBAR_RIGHT_UP, self.OnTrayRight)

		#http://mail.python.org/pipermail/python-list/2005-April/275096.html  Ʈ ˾
		#wxTaskBarIcon::OnLButtonDClick ʹư Ŭ http://bbs.python.or.kr/viewtopic.php?p=51936&sid=0a1b3cb04072c2058c765c362e4dbbc6
		self.rmenu = wx.Menu()
		wx.ID_SET = 1117
		self.rmenu.Append(wx.ID_EXIT, "&Exit"," Terminate this program")
		self.rmenu.Append(wx.ID_ABOUT, "&About"," Information about this program")
		self.rmenu.Append(wx.ID_SET,"&Setting"," first setting")
		wx.EVT_MENU(self, wx.ID_SET, self.OnSet)
		wx.EVT_MENU(self, wx.ID_ABOUT, self.OnAbout)
		wx.EVT_MENU(self, wx.ID_EXIT, self.OnExit)

		test = easyhanrss.conhan('nakada@nate.com','wow0909')
		zone_list = []
		for k in range(len(test)):
			zone_list.append(unicode(test[k],'utf-8'))
		
		pn = wx.Panel(self, -1)
		mainSz = wx.BoxSizer(wx.VERTICAL)
		
		self.posx = "800"
		self.posy = "600"

		self.sizex = "210"
		self.sizey = "130"
        
		"How Long The Popup Will Stay\nAround After It Is Launched"
		self.linger = "4000"

		"How Long It Takes The Window To \"Fade\" In And Out"
		self.scrollspeed = "8"
		self.backimage = "bg.bmp"

		popupText1 = zone_list[0]
		self.popupText1 = popupText1

		self.ButtonDown()
		
		pn.SetAutoLayout(True)
		pn.SetSizer(mainSz)
		pn.Fit()

	def OnSet (self, event):
		dlg = TestDialog(self, -1, "This is a Dialog", size=(350, 200), style = wx.DEFAULT_DIALOG_STYLE)
		dlg.CenterOnScreen()
		val = dlg.ShowModal()

	def OnAbout (self, event):
		m = wx.MessageDialog( self, "Hi this is \n HanRss","Title", wx.OK)
		m.ShowModal()
		m.Destroy

	def OnTrayRight (self, evt):
		self.PopupMenu(self.rmenu)

	def OnExit(self, evt):
		#α׷ 
		self.tbicon.Destroy()
		self.Close(True)
		wx.GetApp().ProcessIdle()

	def ButtonDown(self):
		windowstyle = TB.DEFAULT_TB_STYLE
		tbstyle = TB.TB_SIMPLE

		#TB.TB_ONTIME     TB.TB_ONCLICK
		closingstyle = TB.TB_ONCLICK
		tb = TB.ToasterBox(self, tbstyle, windowstyle, closingstyle)

		sizex = int(self.sizex)
		sizey = int(self.sizey)
		tb.SetPopupSize((sizex, sizey))

		posx = int(self.posx)
		posy = int(self.posy)
		tb.SetPopupPosition((posx, posy))
		
		tb.SetPopupPauseTime(int(self.linger))
		tb.SetPopupScrollSpeed(int(self.scrollspeed))

		self.RunSimpleDemo(tb)
		tb.Play()

	def RunSimpleDemo(self, tb):
		dummybmp = wx.Bitmap(self.backimage, wx.BITMAP_TYPE_BMP)

		if dummybmp.Ok():
			tb.SetPopupBitmap(self.backimage)
		else:
			tb.SetPopupBitmap()
		
		txtshown = self.popupText1
		tb.SetPopupText(txtshown)


class TestDialog(wx.Dialog):
    def __init__(
            self, parent, ID, title, size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE
            ):

        # Instead of calling wx.Dialog.__init__ we precreate the dialog
        # so we can set an extra style that must be set before
        # creation, and then we create the GUI dialog using the Create
        # method.
        pre = wx.PreDialog()
        pre.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
        pre.Create(parent, ID, title, pos, size, style)

        # This next step is the most important, it turns this Python
        # object into the real wrapper of the dialog (instead of pre)
        # as far as the wxPython extension is concerned.
        self.PostCreate(pre)

        # Now continue with the normal construction of the dialog
        # contents
        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, "This is a wx.Dialog")
        label.SetHelpText("This is the help text for the label")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Field #1:")
        label.SetHelpText("This is the help text for the label")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        text = wx.TextCtrl(self, -1, "", size=(80,-1))
        text.SetHelpText("Here's some help text for field #1")
        box.Add(text, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Field #2:")
        label.SetHelpText("This is the help text for the label")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        text = wx.TextCtrl(self, -1, "", size=(80,-1))
        text.SetHelpText("Here's some help text for field #2")
        box.Add(text, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)

        btnsizer = wx.StdDialogButtonSizer()
        
        if wx.Platform != "__WXMSW__":
            btn = wx.ContextHelpButton(self)
            btnsizer.AddButton(btn)
        
        btn = wx.Button(self, wx.ID_OK)
        btn.SetHelpText("The OK button completes the dialog")
        btn.SetDefault()
        btnsizer.AddButton(btn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("The Cancel button cnacels the dialog. (Cool, huh?)")
        btnsizer.AddButton(btn)
        btnsizer.Realize()

        sizer.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)

def main():
	app = wx.PySimpleApp()
	frame = ToasterBoxDemo(None)
	frame.Show()
	app.MainLoop()

if __name__ == "__main__":
	main()